//+------------------------------------------------------------------+
//|                                 Synchronize_Bars_Use_OnTimer.mq5 |
//|                        Copyright 2011, MetaQuotes Software Corp. |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2011, MetaQuotes Software Corp."
#property link      "http://www.mql5.com"
#property version   "1.00"
//--- input parameters
input string   other_symbol="USDJPY";
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//---   
   if(_Symbol==other_symbol)
     {
      PrintFormat("         !");
      //---    
      return(-1);
     }
//---  
   EventSetTimer(5);
//---
   return(0);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---  
   EventKillTimer();
  }
//+------------------------------------------------------------------+
//| Timer function                                                   |
//+------------------------------------------------------------------+
void OnTimer()
  {
//---        
   static datetime last_bar_time=0;
//---   ,         
   static bool synchonized=false;

//---     
   if(last_bar_time==0)
     {
      //---   ,     
      last_bar_time=(datetime)SeriesInfoInteger(_Symbol,Period(),SERIES_LASTBAR_DATE);
      PrintFormat("  last_bar_time  %s",TimeToString(last_bar_time));
      return;
     }

//---        
   datetime curr_time=(datetime)SeriesInfoInteger(Symbol(),Period(),SERIES_LASTBAR_DATE);
//---         ,    last_bar_time
   if(curr_time!=last_bar_time)
     {
      //---        
      last_bar_time=curr_time;
      //---  ,    false
      synchonized=false;
      //---     
      PrintFormat("  %s     %s",_Symbol,TimeToString(TimeCurrent()));
     }
//---        
   datetime other_time=(datetime)SeriesInfoInteger(other_symbol,Period(),SERIES_LASTBAR_DATE);
   if(curr_time==other_time && !synchonized)
     {
      //---        
      synchonized=true;
      PrintFormat("       %s: %s",_Symbol,TimeToString(last_bar_time));
      PrintFormat("      %s: %s",other_symbol,TimeToString(other_time));
      //--- TimeCurrent()  ,  TimeTradeServer()  
      PrintFormat("   %s",TimeToString(TimeTradeServer(),TIME_SECONDS));
     }
  }
//+------------------------------------------------------------------+
